unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, PakExplr, Buttons, FileCtrl;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    FilenameEdit1: TFilenameEdit;
    Label2: TLabel;
    ListBox1: TListBox;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    PakExplr1: TPakExplr;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: PakExplr1.ResourceType:= ptAll;
    1: PakExplr1.ResourceType:= ptDemos;
    2: PakExplr1.ResourceType:= ptEnv;
    3: PakExplr1.ResourceType:= ptMaps;
    4: PakExplr1.ResourceType:= ptModels;
    5: PakExplr1.ResourceType:= ptPics;
    6: PakExplr1.ResourceType:= ptSound;
    7: PakExplr1.ResourceType:= ptSprites;
    8: PakExplr1.ResourceType:= ptTextures;
  end;
  PakExplr1.PakFile:= FilenameEdit1.Text;
  ListBox1.Clear;
  if PakExplr1.Execute then
    ListBox1.Items.Assign(PakExplr1.ResourceList);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  MessageDlg('Delphi 4.0 component: TPakExplr'+#13+#10+''+#13+#10+'This component allows you to list the resource types'+#13+#10+'found in a Quake2 PAK file. You can find a specific'+#13+#10+'resource type, or list all resources.'+#13+#10+''+#13+#10+'Source is included. I have not tested it in any version'+#13+#10+'besides Delphi 4.0, and I believe it will only work with'+#13+#10+'Quake2 PAK files.'+#13+#10+''+#13+#10+'author: Dave Lehman, Angstrom Software'+#13+#10+'website: http://www.futuresights.com/~angstrom/'+#13+#10+'e-mail: angstrom@iname.com', mtInformation, [mbOK], 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if DirectoryExists('c:\quake2\') then
    FilenameEdit1.Filename:= 'c:\quake2\baseq2\pak0.pak';
  ComboBox1.ItemIndex:= 0;
end;

end.
